
require "defines"
require "util"


game.on_event(defines.events.on_tick, function(event)

		if (game.tick % 25000) == 0 then
			change_wind_day()
		end

		if (game.tick % 2500) == 0 then
			change_wind_hour()
		end

		if (game.tick % 125) == 0 then
			check_generators()
		end
end)




game.on_event(defines.events.on_built_entity, function(event)

	if event.created_entity.name == "wind-turbine" then	
			local wind_turbine = event.created_entity
						if global.wind_turbine == nil
						then global.wind_turbine = {}
						end
					table.insert(global.wind_turbine, wind_turbine)
					wind_turbine.fluidbox[1] = {type="wind", amount=100, temperature=(game.wind_speed*2500)}

	end
end)


game.on_event(defines.events.on_robot_built_entity, function(event)

	if event.created_entity.name == "wind-turbine" then		
			local wind_turbine = event.created_entity
						if global.wind_turbine == nil
						then global.wind_turbine = {}
						end
					table.insert(global.wind_turbine, wind_turbine)
					wind_turbine.fluidbox[1] = {type="wind", amount=100, temperature=(game.wind_speed*2500)}
	end
end)



function check_generators()
   if global.wind_turbine ~= nil then
      for k,gen in pairs(global.wind_turbine) do
					if gen.valid then
         				if gen.fluidbox[1] ~= nil then 
         				local pot = gen.fluidbox[1]
						pot["amount"] = 10



						local w = game.wind_speed*2500

						local dw = pot["temperature"] - w
						if dw > 1 then
							pot["temperature"] = pot["temperature"] - 1
						end

						if dw < -1 then
							pot["temperature"] = pot["temperature"] + 1
						end

						if game.wind_speed == 0 and pot["temperature"] < 2
							then pot["temperature"] = 0
						end

						--pot["temperature"] = 100*(game.wind_speed*25)
						gen.fluidbox[1] = pot


						else table.remove(global.wind_turbine, k)
end				
end
end
end
end
				
function change_wind_hour()

	if global.wind_day == nil
		then global.wind_day = 1
	end
local rand = math.random() / 25
game.wind_speed = rand*global.wind_day
end

function change_wind_day()
	if global.wind_day == nil
		then global.wind_day = 1
		end

	global.wind_day = math.random(0.8,1.2)
end
				
			
